/* **************************************************************************
;																			*
;	Filename: SIRC															*
;	Date: May 29, 2009														*
;	File Version: 001														*
;																			*
;	Author:   Jason Lopez													*
;	Company:  AtomSoft														*
;																			*
;****************************************************************************
; Notes:
;
*/
#include <p18f1320.h>
#include <delays.h>
#include <string.h>

#pragma config WDT = OFF, LVP = OFF, OSC = INTIO2, MCLRE = OFF

#define irTris TRISAbits.TRISA0
#define irPin  LATAbits.LATA0

#define UpTris  TRISBbits.TRISB5
#define DwnTris TRISBbits.TRISB4

#define Up_Btn  PORTBbits.RB5
#define Dwn_Btn PORTBbits.RB4


void main(void);
void SendSIRC(unsigned char Dev, unsigned char Cmd);
void PulseIt(unsigned char time);

void main(void){

    char tmp;
    OSCCON = 0x72;                  //8MHz clock
    while(!OSCCONbits.IOFS);        //wait for osc stable
    ADCON1 = 0xFF;

    UpTris = 1;
    DwnTris = 1;
    irTris = 0;

    SendSIRC(1,1);
    while(1){
        if(Up_Btn == 0){
            SendSIRC(1,0);
            Delay10KTCYx(1);
        }
        if(Dwn_Btn == 0){
            SendSIRC(1,1);
            Delay10KTCYx(1);
        }
    }
}

void SendSIRC(unsigned char Dev, unsigned char Cmd){
    char x;
    PulseIt(4);             //Logic Start

    for(x=0;x<7;x++){
        if(Cmd & 0x01)
            PulseIt(2);     //Logic 1
        else
            PulseIt(1);     //Logic 0
        Cmd <<= 1;
    }
    for(x=0;x<5;x++){
        if(Dev & 0x01)
            PulseIt(2);     //Logic 1
        else
            PulseIt(1);     //Logic 0
        Cmd <<= 1;
    }
    Delay10KTCYx(90);       //45mS Delay
}

void PulseIt(unsigned char time){
    unsigned char x,y,z;

for(y=0;y<time;y++){
    for(x=0;x<24;x++){          //600uS worth
        irPin = 1;
        Delay10TCY();
        Nop();
        Nop();
        Nop();                  //About 7uS
        irPin = 0;
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Delay10TCY();
        Delay10TCY();           //About 18uS
    }
}

    for(x=0;x<24;x++){          //600uS worth
        irPin = 0;
        Delay10TCY();
        Nop();
        Nop();
        Nop();                  //About 7uS
        irPin = 0;
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        Delay10TCY();
        Delay10TCY();           //About 18uS
    }
}
